use crate::{partials, Station};
use axum::{extract::State, response::IntoResponse, routing::get, Router};
use maud::{html, Markup};
use sqlx::SqlitePool;
use std::sync::Arc;
use tower_sessions::Session;

async fn station_picker(State(db): State<Arc<SqlitePool>>, session: Session) -> Markup {
    let stations = Station::all(&db).await;
    let content = html! {
        h1 { "Wähle deine Station" }
        select onchange="window.location.href='/s/' + this.value;" {
            option selected value="" {
                "Deine Station..."
            }
            @for station in stations {
                option value=(station.id) { (station.name) };
            }
        }

    };
    partials::page(content, session, false).await
}

async fn view(
    State(db): State<Arc<SqlitePool>>,
    session: Session,
    axum::extract::Path(id): axum::extract::Path<i64>,
) -> Markup {
    //let Some(route) = Route::find_by_id(&db, id).await else {
    //}
    todo!()
}

pub(super) fn routes() -> Router<Arc<SqlitePool>> {
    Router::new()
        .route("/", get(station_picker))
        .route("/{id}", get(view))
}
